Fri Apr 22 09:08:05 1994  George_A_Howlett  (gah@grenache)

	* src/bltTable.c (TableCmd): Check argument count before
	attempting to retrieve the named table.

Thu Apr 21 09:35:17 1994  George_A_Howlett  (gah@grenache)

	* src/bltGrAxis.c (GetAxisGeometry): Changed tick label allocation
	scheme to allocate a single character pool, instead of multiple
	allocations for each label.

Wed Apr 20 20:18:33 1994  George_A_Howlett  (gah@grenache)

	* src/bltBitmap.c (DefineBitmap): Fixed bug of elemArr
	being freed twice (in cases where bitmap is already defined).
	
Fri Mar 11 11:37:19 1994  George_A_Howlett  (gah@grenache)

	* src/bltGrAxis.c (axisNames): Fixed order of axis names.
	Wasn't consistent with enumerated type.

Mon Mar  7 14:55:51 1994  George_A_Howlett  (gah@grenache)

	* src/bltDragDrop.c (AddDDProp): Read-only string changed 
	to static array for call to Tcl_Eval.

	* src/bltBgexec.c: Added sigNum field to BackgroundInfo 
	to handle user-defined signals.

	* src/bltBgexec.c (DestroyBackgroundInfo): New procedure
	called by Tk_EventuallyFree. infoPtr->outputName was being
	free-ed in CleanupProc while other traces could still be 
	pending for it.  Thanks to Greg Schmid (sp?) 
	(schmid@fb3-s7.math.tu-berlin.de) for the report and fix.

Thu Feb 24 09:27:54 1994  George_A_Howlett  (gah@grenache)

	* src/bltGrPS.c (Blt_PrintLine): Note that variable i should 
	be (numPoints - 1) before drawing outputing last line segment.  

	* src/bltGrTag.c (PrintLine): Scratch buffer was appended 
	twice to interp->result in line tag print routine.  Many 
	thanks to Lou Salkind (salkind@deshaw.com) for the report 
	and fixes.

Tue Feb  8 13:38:27 1994  George_A_Howlett  (gah@grenache)

	* src/Makefile.in (all): Fixes for cross-architecture
	builds/installs.  Thanks to Terri L. Fischer (terri@ner.com)
	for the report and the fix.

	* src/bltInit.c (BLT_VERSION): Update version number.

	* src/bltGrAxis.c (xAxisConfigSpecs): Added -descending
	configuration option to specify if the axis values are increasing
	or decreasing.

	* src/bltGrAxis.c (Blt_TransformDist): Could return negative
	distances, now returns absolute value of distance.

	* src/bltGrAxis.c (Blt_TransformPt): Added test of inverted
	axes.  Need to swap x and y coordinates.

	* src/bltGrAxis.c (Baseline, Tick): Checks for descending scale.

	* src/bltGrAxis.c (Blt_Transform): Checks for descending scale.
	Changed test from X/Y to horizontal/vertical axes.

	* src/bltGraph.c (configSpecs): Added -invertxy configuration
	option to invert the x and y axes.

	* src/bltGrElem.c (LayoutBar): Checks for inverted axes, and
	while setting x and y values for the bars.

	* src/bltGrElem.c (GetBarLimits): Now correctly calculates the
	min or max or stack bar segments with both positive and negative 
	values.

Wed Feb  2 15:43:33 1994  George_A_Howlett  (gah@grenache)

	* README: Updated for BLT-1.4


Tue Feb  1 09:34:39 1994  George_A_Howlett  (gah@grenache)

	* src/bltGraph.c (WindowCoords): Was returning an extra list 
	around the coordinate values.  Thanks to Wolf D. Ihlenfeldt
	(wolf@molout.tutkie.tut.ac.jp) for the fix.

Mon Jan 31 12:00:19 1994  George_A_Howlett  (gah@grenache)

	* src/bltGrTag.c (Blt_TagCmd): Bad check for wrong # args in the
	"tag coords" command.  Thanks to Wolf D. Ihlenfeldt
	(wolf@molout.tutkie.tut.ac.jp) for the fix.

	* src/bltGrTag.c (lineConfigSpecs): Changed -width option to
	-linewidth. Now agrees with the manual. Thanks to Wolf
	D. Ihlenfeldt (wolf@molout.tutkie.tut.ac.jp) for the fix.

	* src/bltGrTag.c (bitmapConfigSpecs): Changed -pattern option to
	-bitmap. Now agrees with the manual. Thanks to Wolf D. Ihlenfeldt
	(wolf@molout.tutkie.tut.ac.jp) for the fix.

Thu Jan 27 11:59:51 1994  George_A_Howlett  (gah@grenache)

	* src/bltGrAxis.c (Blt_ComputeLayout): Calculations for tick
	labels are slightly off, causing x and y2 axes to be cut off when
	the axis title is displayed.  Remedy by adding half the title font
	height to balance things.

Wed Jan 26 11:26:30 1994  George_A_Howlett  (gah@grenache)

	* src/bltGrElem.c (ClosestElement): Reversed the order in
	searching elements, from last drawn to first.  When two elements
	have the same closest data point, we want to select the one drawn
	last.  Thanks to Wolf D. Ihlenfeldt (wolf@molout.tutkie.tut.ac.jp)
	for the fix.

Fri Jan 21 09:47:15 1994  George_A_Howlett  (gah@grenache)

	* src/bltWatch.c (Blt_WatchInit): Created new command "blt_watch".
	Calls "pre" and "post" Tcl procs before and after Tcl commands.
	Allows for simple tracing, profiling, debugging routines to be
	created.  Needs a good variable trace demo.

	* src/bltHtext.c (CreateTraces): Changed command argument of
	Tcl_Eval from a static string to prevent "gcc"-compiled versions
	from dumping core.  Thanks to molli@lorraine.loria.fr for the
	bug-report.

	* src/bltHtext.c (GotoLine): Off-by-one error when bounding
	gotoline values.  Thanks to Doug (bogia@cs.uiuc.edu) for the fix.

	* src/bltGrElem.c (UpdateVector): Added call to
	GetDataLimits(vecPtr) so that element autoscales correctly.
	Thanks again to Joe VanAndel (vanandel@ncar.ucar.edu), who has
	found and fixed (sadly far too) many bugs in the blt_graph C
	interface.

Wed Jan 19 11:50:07 1994  George_A_Howlett  (gah@grenache)

	* src/bltGrAxis.c (UpdateLimits): Fixed axis limits when only one
	of the limits (either min or max) is autoscaled.  Was possible to
	have manual limit conflict with auto.

Tue Jan 18 15:52:24 1994  George_A_Howlett  (gah@grenache)

	* src/bltGrAxis.c (UpdateLimits): Set arbitrary axis limits before
	testing the range.  Thanks to Gordon Lack (gml4410@ggr.co.uk) for
	the bug report.

	* src/bltDragDrop.c: 
	Changes static char * values to #defines. Make use strdup().
	Check if malloc-ed pointers are NULL before deallocating.
	Thanks to diekema@snoopy.si.com for the patch.

	Added tokenOutline an configuration option.

	* src/bltGrAxis.c: Added prevMin, prevMax fields to Axis
	structure.

Mon Jan 17 18:26:54 1994  George_A_Howlett  (gah@grenache)

	(xAxisConfigSpecs, etc.):  Removed "Axis" from option
	names. Only option classes has "Axis" now.  Created
	configSpecs for alternate axes (x2 and y2).

Mon Jan 10 17:26:53 1994 George_A_Howlett (gah@grenache)

	* feature (bltGrAxis.c, bltGrTag.c, bltGrElem.c) 
	  - added alternate x-axis (x2).
	  - added -mapx, -mapy options (removed -axis) to tags
	    and elements
	  - can map element or tag to both axes, but elements still get
	    mapped to first axis.
	  - removed axis title options from general widget configuration.
	  
Thu Jan  6 18:38:33 1994  George_A_Howlett  (gah@grenache)

	* Changed kosherdill-1.0 directory to kosherdill.

	*  bugfix (kosherdill) main.tcl
	  - removed suppression of drag&drop error messages
	  - added check to make sure that "send" command is operational

        * bugfix (Makefile.in) Added missing \ to install-dirs target.
	  Thanks to Dan Mack (mack@cray.com)

	* new features (blt_barchart/blt_graph): 

	  Added alternate y-axis.  New ipad and pad options to legend.
	  Data vectors are allocated in doubled-size chunks.  Element line
	  segments are pre-calculated and saved in SegInfo structure.

	* bugfix (bltBgexec.c)

          Introduced bug in last release. FixNewline and UnfixNewline
	  called with wrong number of arguments.  Many thanks to Dan Mack
	  (mack@cray.com), Mark Sterin (mark@lannet.com), Elchonon
	  (elchonon@wayne.unix.landmark.com), and Cary Renzema
	  (caryr@tekig6.pen.tek.com) for their bug reports and fixes.

	* bugfix (bltGrAxis.c)

          Introduced bug in last release. Reported errors when empty
	  strings passed as arguments to axis -min, -max options.  Thanks
	  to Tim Medley (tlm@frb.gov) and Gordon Lack (gml4410@ggr.co.uk)
	  for their bug reports and fixes.
	
	* feature (bltGrAxis.c, bltGrTag.c bltGrElem.c) extra y-axis.
	  Added secondary y-axis "y2".
	  New axis configuration option: -mapped

	  New element configuration option -axis: select which y-axis to
	  map element y-coordinates onto.

	  Added -axis option to all tags.  Indicates which y-axis to
	  map tag y-coordinates onto.

	* feature (AppendVector, UpdateVector)
	  use more efficient size-doubling algorithm for adding space 
	  to the vector.  

	* feature (bltGrLegd.c) 
	  New configuration options: ipadx, ipady, padx, pady


	* bugfix (bltTable.c) Called LayoutTable with too few arguments.

Thu Dec 16 15:42:50 1993  George_A_Howlett  (gah@grenache)

	* bugfix (all) Command initialization routines all now
	return TCL_OK or TCL_ERROR (instead of void).
	
	* bugfix (bltInit.c) All calls to BLT command initialization 
	routines are checked for TCL_OK.  The first error knocks
	you out of the BLT init routine.

	* bugfix (all) All source files now include blt.h.  Includes
	prototype for Blt_FindCmd (remove prototypes from files).
	Also, move include directives for <stdlib.h> and <string.h>
	into blt.h.  Now checks HAVE_STRLIB_H, HAVE_STRING_H before
	attempting to include.

	* bugfix (all) Added prototype for strdup(). Check for sun, 
	since the SunOS 4.x and 5.x prototypes conflict.

	* bugfix (all)  Removed prototype of toupper(). Was causing
	errors on other systems.

	* bugfix (bltGrMisc.c) Added replacement routines for
	strcasecmp() and strncasecmp() if the C library doesn't
	contain either of them.
	
	* bugfix (bltGraph.h, bltGrAxis.c bltGrElem.c bltGraph.c) 
	Removed all references to math routines exp10, rint, sincos,
	fabs, and abs.  Supply replacement macro definitions instead.
	This is to facilitate dynamic loading of a shared BLT library.
	Can't add math routines not already used in libtcl.a.  

	* bugfix (bltGraph.h bltGraph.c) Look for MAX_DBL and
	MIN_DBL in ANSI float.h instead of using HUGE_VAL.  Will
	still use HUGE_VAL for non-ANSI compilers, except for Sun.
	On SunOS 4.x, don't want to drag in __infinity from math
	library.  Will provide hard numbers instead.  If HUGE_VAL
	can't be found, use HUGE.  Again, this facilitates dynamic
	loading of BLT as a shared library.

	* bugfix (bltGrMisc.c) Removed sincos, exp10 replacements. 

	* bugfix (bltGrElem.c) Check for odd number of coordinates in
	in "element append" command.

	* bugfix (bltGrElem.c) In Blt_GraphElement(), don't append data.
	Reset the element data instead.   Also, mark the element for re-
	layout.  Thanks to Joe VanAndel (vanandel@ncar.ucar.edu) for
	the patch.
	
	* bugfix (bltDragDrop.c) "source" option with no arguments was
	trying to return configuration information for NULL window

	* feature (bltGraph.c) Added -halo configuration option.  Sets
	a threshold distance when searching elements for closest points.

	* feature (bltGrElem.c) Added "element closest" command.  Searches
	elements for closest point, returning list of information.

	* feature (bltGrElem.c) Added element -activeforeground and
	-activebackground options with "element activate" command.  
	Highlights data points using the element's active colors.

	* feature (bltGraph.c) Added "transform" command.  Transforms
	graph coordinates into window coordinates.  Also changed "locate"
	command to "invtransform".  

	* bugfix (bltGrElem.c) Data print routines now use Tcl dynamic
	strings instead of malloc-ing own space.

	* feature (bltGrElem.c) Barchart element -foreground option now
	can take a list of colors.  Extra colors are used with elements
	containing multiple y data points. 

	* feature (bltGrTag.c) Changed "tag identifiers" command to 
	"tag ids".
	
	* bugfix (bltGrTag.c) Check number of arguments for tag command.
	
	* bugfix (bltGrTag.c) Test for "-Inf" and "Inf" before trying
	Tcl_ExprDouble.  On sun's this is automatically converted to
	-HUGE_VAL and HUGE_VAL.  
	
	* feature (bltGraph.h, bltGraph.c, bltGrHairs) Added -color 
	option to crosshairs.   

Wed Nov 24 14:15:59 1993  George_A_Howlett  (gah@grenache)

	* bugfix (bltInit.c, etal) Changed format of Blt_*Init 
	routines to extension proposal.

Wed Nov 24 12:06:38 EST 1993  Michael_J_McLennan  (mmc@gewurtz)

	* bugfix (bltUtil.c)  Removed error message from Blt_FindCmd.

	* bugfix (kosherdill/Makefile.in) Added space to sed command.
	Thanks to Mark Brucks (brux@chpc.utexas.edu) for the fix.

	* bugfix (kosherdill/Makefile.in) Failed to create new library
	directory properly.
	
	* bugfix (configure.in)  Made BLT_LIBRARY a separate configurable
	variable.  Don't assume install directory to be @prefix@/library.
	Thanks to Scott Schwartz (schwartz@groucho.cse.psu.edu) for
	the report.

Fri Nov 19 17:21:32 1993  George_A_Howlett  (gah@grenache)

	* ------- Released BLT-1.0 -------

=======
	* bugfix (bltDragDrop.c) Fixed memory leak for drag&drop
	source handlers.

------- Released BLT-1.0 -------

>>>>>>> 1.2
Sat Nov 13 18:01:15 1993  George_A_Howlett  (gah@grenache)

	* feature (kosherdill) BLT's first application!  Probes 
	your file system for large and moldy files. Many thanks
	to Michael McLennan (michael.mclennan@att.com) for adding it 
	to the BLT distribution.  It's also a great demonstation of 
	the new "blt_drag&drop" command.

	* bugfix (bltHtext.c) Added TK_CONFIG_NULL_OK flag to 
	-filename option. This allows clearing of the widget by 
	simply configuring the filename to the empty string.

	* bugfix (bltHtext.c) Reverse search was completely wrong.
	Thanks to Allan Brighton (allan@piano.sta.sub.org) for the
	fix. 

	* bugfix (bltHtext.c) Scanning was improperly scaled by 
	x or y scrollunits. 

	* bugfix (bltHtext.c) Errors in configuring the htext 
	widget were not properly propagated back. Removed all that 
	"goto redisplay" silliness. Thanks to Micheal McLennan 
	(micheal.mclennan@att.com) for the report.

	* feature (bltDebug.c)  A simple command trace facility.  
	It's interface and functionality will probably change in the
	next release.

	* feature (bltInit.c, src/Makefile)  Added a new variable
	$blt_library indicating where the graph prolog and drag&drop 
	protocols are.  Can be set by BLT_LIBRARY variable and is
	defined in the library.

	* feature (bltDragdrop.c) Micheal McLennan has 
	(micheal.mclennan@att.com) gratiously added his wonderful 
	drag&drop facility (he still maintains it).  See the "palette" 
	demo.

	* feature (bltBgexec.c) Added -outputvar switch to 
	"blt_bgexec" command.  I keep putting switches after the
	output variable name, when it should be before. So maybe
	this is more intuitive.  The old syntax still works.

	* change:  Eliminated use of Imakefiles altogether. This 
	was prompted by the new shared library target.  I still
	like imake, but don't want to mediate the differences 
	between R4 and R5 imake.  

	* feature (Makefile) Added install targets for demo, library,
	shared library, and manuals.   Thanks to Scott Schwartz 
	(schwartz@roke.cse.psu.edu) for the suggestion. Shared 
	library target only knows about SunOS, Solaris, and HP-UX
	right now.

Fri Oct 15 17:17:12 1993  George_A_Howlett  (gah@grenache)

	* bugfix (bltGrTag.c) Added missing options -xoffset
	and -yoffset to the text tag.  Thanks to Mike Halazar
	(halazar@media.mit.edu) for the fix.

	* feature (bltBgexec.c) Added switches to "blt_bgexec"
	command (-keepnewline, -updatevar, -errorvar). Can now
	collect stderr in a variable.  Also can get updates
	of data as it is read from the pipe.  See demo "bgexec".

Wed Sep 29 20:58:01 1993  George_A_Howlett  (gah@grenache)

	* bugfix (bltHtext.c) Event handler and hash table entry
	for child subwindows were not being removed when freeing
	lines or when a child window was destroyed.  Thanks to
	Micheal McLennan (micheal.mclennan@att.com) for the fix.

	* feature (bltHtext.c) Added "children" option to display
	all the child windows the htext widget thinks it has. It 
	was for debugging, but I'll leave it in anyway.

Mon Sep 20 13:08:33 1993  George_A_Howlett  (gah@grenache)

	* bugfix (bltTable.c) Changed number of arguments passed to 
	ConfigureCubicle.  Now conforms with usage in TableCmd.
	Thanks to Angel Li (angel@flipper.rsmas.miami.edu) for the
	fix.

------- Released BLT-1.0b2 -------

Fri Sep 10 10:50:39 1993  George_A_Howlett  (gah@grenache)

	* bugfix (configure.in) Added tests to check for bogus
	math library functions sincos and rint.

Thu Sep  9 13:00:50 1993  George_A_Howlett  (gah@grenache)

	* bugfix (bltGraph.h, bltGrMisc.c) for HP architectures
	sincos() and rint() return bogus results.  Thanks to John 
	Robert LoVerso (loverso@osf.org) for tracking it down and 
	supplying the fix.

	* bugfix (grconf.tcl, busy) clean up demos

	* bugfix (configure.in) search for TK_LIBDIR failed to look
	in ../tk3.3b3.  Added non-beta directory names to search.

	* bugfix (bltGrElem.c) Data vectors for lines and bar were 
	not released.

	* bugfix (bltGrLegd.c) Memory for legend structure was not freed.

	* bugfix (bltGrPS.c) Memory for postscript structure was not freed.
	
	* (bltGrMisc.c) removed unused Blt_CreateGC routine.

Wed Sep  8 11:22:32 1993  George_A_Howlett  (gah@grenache)

	* bugfix (tkAppInit.c) Replaced with tk3.3b3 version.  Thanks to
	Philippe Defert (defert@gnuisance.cern.ch).

	* bugfix (configure.in) TCL_INCDIR and TK_INCDIR mistakenly have
	tcl.h and tk.h suffixes for certain configurations. Thanks to
	Gerald Fowler (gfowler@wilkins.iaims.bcm.tmc.edu).

------- Released BLT-1.0b1 -------
